package numberprogressbarwrapper;

import main.java.com.daimajia.numberprogressbar.NumberProgressBar;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("NumberProgressBar")
public class numberProgressBarWrapper extends ViewWrapper<NumberProgressBar> implements DesignerCustomView {


        private BA ba;
	private String eventName;
	 
	/*
	 * Initialize the HTML-TextView 
	 */   	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}
	
	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		this.setObject(new NumberProgressBar(ba.context));
 	}

	//programmatically add view
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(this.getObject(), new BALayout.LayoutParams(left, top, width, height));
	}

	//this method cannot be hidden.
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}
	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		lp.left = left;
		this.getObject().getParent().requestLayout();
	}
	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		lp.top = top;
		this.getObject().getParent().requestLayout();
	}
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)this.getObject().getLayoutParams();
		return lp.top;
	}
	

//    public void setTargetValue(float value) {
//            this.getObject().setTargetValue(value);
//            this.getObject().invalidate();
//    }




    /**
     * Get progress text color.
     *
     * @return progress text color.
     */
    public int getTextColor() {
        return this.getObject().getTextColor();
    }

    /**
     * Get progress text size.
     *
     * @return progress text size.
     */
    public float getProgressTextSize() {
        return this.getObject().getProgressTextSize();
    }

    public int getUnreachedBarColor() {
        return this.getObject().getUnreachedBarColor();
    }

    public int getReachedBarColor() {
        return this.getObject().getReachedBarColor();
    }

    public int getProgress() {
        return this.getObject().getProgress();
    }

    public int getMax() {
        return this.getObject().getMax();
    }

    public float getReachedBarHeight() {
        return this.getObject().getReachedBarHeight();
    }

    public float getUnreachedBarHeight() {
        return this.getObject().getUnreachedBarHeight();
    }

    public void setProgressTextSize(float textSize) {
            this.getObject().setProgressTextSize(textSize);
            this.getObject().invalidate();
    }

    public void setProgressTextColor(int textColor) {
            this.getObject().setProgressTextColor(textColor);
            this.getObject().invalidate();
    }

    public void setUnreachedBarColor(int barColor) {
            this.getObject().setUnreachedBarColor(barColor);
            this.getObject().invalidate();
    }

    public void setReachedBarColor(int progressColor) {
            this.getObject().setReachedBarColor(progressColor);
            this.getObject().invalidate();
    }

    public void setReachedBarHeight(float height) {
            this.getObject().setReachedBarHeight(height);
            this.getObject().invalidate();
    }

    public void setUnreachedBarHeight(float height) {
            this.getObject().setUnreachedBarHeight(height);
            this.getObject().invalidate();
    }

    public void setMax(int maxProgress) {
            this.getObject().setMax(maxProgress);
            this.getObject().invalidate();
    }

    public void setSuffix(String suffix) {
            this.getObject().setSuffix(suffix);
            this.getObject().invalidate();
    }

    public String getSuffix() {
        return this.getObject().getSuffix();
    }

    public void setPrefix(String prefix) {
            this.getObject().setPrefix(prefix);
            this.getObject().invalidate();
    }

    public String getPrefix() {
        return this.getObject().getPrefix();
    }

    public void incrementProgressBy(int by) {
            this.getObject().incrementProgressBy(by);
            this.getObject().invalidate();
    }

    public void setProgress(int progress) {
            this.getObject().setProgress(progress);
            this.getObject().invalidate();
    }



}
